;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*=====================================================================*/
;*    .../interface.scm ...                                            */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Aug 26 17:02:41 1993                          */
;*    Last change :  Thu Aug 26 17:22:56 1993 (serrano)                */
;*    -------------------------------------------------------------    */
;*    L'interface entre la passe `lift' et la passe `integ'            */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module lift_interface
	(export (add-celled! var)
		(get-all-celled-variable)))

;*---------------------------------------------------------------------*/
;*    *celled-variable* ...                                            */
;*---------------------------------------------------------------------*/
(define *celled-variable* '())

;*---------------------------------------------------------------------*/
;*    add-celled! ...                                                  */
;*---------------------------------------------------------------------*/
(define (add-celled! var)
  (if (not (memq var *celled-variable*))
      (set! *celled-variable* (cons var *celled-variable*))))

;*---------------------------------------------------------------------*/
;*    get-all-celled-variable ...                                      */
;*---------------------------------------------------------------------*/
(define (get-all-celled-variable)
  *celled-variable*)
