;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_labels
  (foreign (include #"caml-bigloo.h"))
  (import
    (__caml_misc #"misc.scm")
    (__caml_buffcode #"buffcode.scm")
    (__caml_instruct #"instruct.scm"))
  (export
    label_table_246@labels
    (reset_label_table_229@labels x1)
    (extend_label_table_197@labels x1)
    (define_label_232@labels x1)
    (out_label_with_orig_230@labels x1)
    (2-131-out_label_with_orig_230@labels x1 x2)
    (out_label_131@labels x1)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define label_table_246@labels
  (make-cell (caml-make-tag 0 0)))

(define reset_label_table_229@labels
  (lambda (x1)
    (begin
      (cell-set!
        label_table_246@labels
        (make-vector
          16
          (caml-make-regular (caml-make-tag 1 2) 1 '())))
      (caml-make-tag 0 1))))

(define extend_label_table_197@labels
  (lambda (x1)
    (let ((x2 (let ((:-d.1000 (cell-ref label_table_246@labels)))
                (if :-d.1000 (vector-length :-d.1000) 0))))
      (let ((x3 (make-vector
                  (*fx (+fx (/fx x1 x2) 1) x2)
                  (caml-make-regular (caml-make-tag 1 2) 1 '()))))
        (begin
          (let ((stop1002 (-fx x2 1)))
            (let for1001 ((i4 0))
              (if (<=fx i4 stop1002)
                (begin
                  (vector-set!
                    x3
                    i4
                    (vector-ref (cell-ref label_table_246@labels) i4))
                  (for1001 (+fx i4 1)))
                (unspecified))))
          (begin
            (cell-set! label_table_246@labels x3)
            (caml-make-tag 0 1)))))))

(define define_label_232@labels
  (lambda (x1)
    (begin
      (if (>=fx x1
                (let ((:-d.1003 (cell-ref label_table_246@labels)))
                  (if :-d.1003 (vector-length :-d.1003) 0)))
        (extend_label_table_197@labels x1)
        (caml-make-tag 0 1))
      (let ((x2 (vector-ref (cell-ref label_table_246@labels) x1)))
        (case (caml-regular-constr-tag x2)
          ((1)
           (fatal_error_193@misc
             #"define_label : already defined"))
          (else
           (let ((x3 (cell-ref out_position_239@buffcode)))
             (begin
               (vector-set!
                 (cell-ref label_table_246@labels)
                 x1
                 (caml-make-regular (caml-make-tag 0 2) 1 x3))
               (let ((x4 (caml-constr-get-field x2 0)))
                 (labels
                   ((staticfail1004
                      ()
                      (begin
                        ((do_list_18@list
                           (lambda (x5)
                             (begin
                               (cell-set!
                                 out_position_239@buffcode
                                 (caml-constr-get-field x5 0))
                               (out_short_156@buffcode
                                 (-fx x3 (caml-constr-get-field x5 1))))))
                         (caml-constr-get-field x2 0))
                        (cell-set! out_position_239@buffcode x3))))
                   (if (null? x4)
                     (caml-make-tag 0 1)
                     (staticfail1004))))))))))))

(begin
  (define out_label_with_orig_230@labels
    (lambda (x1)
      (lambda (x2)
        (2-131-out_label_with_orig_230@labels x1 x2))))
 (define 2-131-out_label_with_orig_230@labels
    (lambda (x1 x2)
      (begin
        (if (eq? x2 nolabel_4@instruct)
          (fatal_error_193@misc
            #"out_label: undefined label")
          (caml-make-tag 0 1))
        (begin
          (if (>=fx x2
                    (let ((:-d.1005 (cell-ref label_table_246@labels)))
                      (if :-d.1005 (vector-length :-d.1005) 0)))
            (extend_label_table_197@labels x2)
            (caml-make-tag 0 1))
          (let ((x3 (vector-ref (cell-ref label_table_246@labels) x2)))
            (case (caml-regular-constr-tag x3)
              ((1)
               (out_short_156@buffcode
                 (-fx (caml-constr-get-field x3 0) x1)))
              (else
               (begin
                 (vector-set!
                   (cell-ref label_table_246@labels)
                   x2
                   (caml-make-regular
                     (caml-make-tag 1 2)
                     1
                     (cons (caml-make-regular
                             (caml-make-tag 0 1)
                             2
                             (cell-ref out_position_239@buffcode)
                             x1)
                           (caml-constr-get-field x3 0))))
                 (out_short_156@buffcode 0)))))))))
)
(define out_label_131@labels
  (lambda (x1)
    ((out_label_with_orig_230@labels
       (cell-ref out_position_239@buffcode))
     x1)))

